diff --git a/drivers/misc/ws2812-pio-rp1.c b/drivers/misc/ws2812-pio-rp1.c
new file mode 100644
index 000000000000..311446a32621
--- /dev/null
+++ b/drivers/misc/ws2812-pio-rp1.c
@@ -0,0 +1,507 @@
+// SPDX-License-Identifier: GPL-2.0
+/*
+ * Raspberry Pi PIO-based WS2812 driver
+ *
+ * Copyright (C) 2014-2024 Raspberry Pi Ltd.
+ *
+ * Author: Phil Elwell (phil@raspberrypi.com)
+ *
+ * Based on the ws2812 driver by Gordon Hollingworth <gordon@raspberrypi.com>
+ */
+
+#include <linux/cdev.h>
+#include <linux/delay.h>
+#include <linux/kernel.h>
+#include <linux/module.h>
+#include <linux/fcntl.h>
+#include <linux/file.h>
+#include <linux/fs.h>
+#include <linux/pio_rp1.h>
+#include <linux/platform_device.h>
+#include <linux/of.h>
+#include <linux/gpio/consumer.h>
+
+#define DRIVER_NAME	"ws2812-pio-rp1"
+#define MAX_INSTANCES	4
+
+#define RESET_US	50
+#define PIXEL_BYTES	4
+
+struct ws2812_pio_rp1_state {
+	struct device	*dev;
+	struct gpio_desc *gpiod;
+	struct gpio_desc *power_gpiod;
+	uint		gpio;
+	PIO		pio;
+	uint		sm;
+	uint		offset;
+
+	u8		*buffer;
+	u8		*pixbuf;
+	u32		pixbuf_size;
+	u32		write_end;
+
+	u8		brightness;
+	u32		invert;
+	u32		num_leds;
+	u32		xfer_end_us;
+	bool		is_rgbw;
+	struct delayed_work deferred_work;
+
+	struct completion dma_completion;
+	struct cdev	cdev;
+	dev_t		dev_num;
+	const char	*dev_name;
+};
+
+static			DEFINE_MUTEX(ws2812_pio_mutex);
+static			DEFINE_IDA(ws2812_pio_ida);
+static long		ws2812_pio_ref_count;
+static struct class	*ws2812_pio_class;
+static dev_t		ws2812_pio_dev_num;
+/*
+ * WS2812B gamma correction
+ *	GammaE=255*(res/255).^(1/.45)
+ *	From: http://rgb-123.com/ws2812-color-output/
+ */
+
+static const u8 ws2812_gamma[] = {
+	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+	0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 2, 2, 2,
+	2, 2, 2, 3, 3, 3, 3, 3, 4, 4, 4, 4, 5, 5, 5, 5,
+	6, 6, 6, 7, 7, 7, 8, 8, 8, 9, 9, 9, 10, 10, 11, 11,
+	11, 12, 12, 13, 13, 13, 14, 14, 15, 15, 16, 16, 17, 17, 18, 18,
+	19, 19, 20, 21, 21, 22, 22, 23, 23, 24, 25, 25, 26, 27, 27, 28,
+	29, 29, 30, 31, 31, 32, 33, 34, 34, 35, 36, 37, 37, 38, 39, 40,
+	40, 41, 42, 43, 44, 45, 46, 46, 47, 48, 49, 50, 51, 52, 53, 54,
+	55, 56, 57, 58, 59, 60, 61, 62, 63, 64, 65, 66, 67, 68, 69, 70,
+	71, 72, 73, 74, 76, 77, 78, 79, 80, 81, 83, 84, 85, 86, 88, 89,
+	90, 91, 93, 94, 95, 96, 98, 99, 100, 102, 103, 104, 106, 107, 109, 110,
+	111, 113, 114, 116, 117, 119, 120, 121, 123, 124, 126, 128, 129, 131, 132, 134,
+	135, 137, 138, 140, 142, 143, 145, 146, 148, 150, 151, 153, 155, 157, 158, 160,
+	162, 163, 165, 167, 169, 170, 172, 174, 176, 178, 179, 181, 183, 185, 187, 189,
+	191, 193, 194, 196, 198, 200, 202, 204, 206, 208, 210, 212, 214, 216, 218, 220,
+	222, 224, 227, 229, 231, 233, 235, 237, 239, 241, 244, 246, 248, 250, 252, 255
+};
+
+// ------ //
+// ws2812 //
+// ------ //
+
+#define ws2812_wrap_target 0
+#define ws2812_wrap 3
+
+#define ws2812_T1 3
+#define ws2812_T2 4
+#define ws2812_T3 3
+
+static const uint16_t ws2812_program_instructions[] = {
+		//     .wrap_target
+	0x6221,	//  0: out    x, 1            side 0 [2]
+	0x1223,	//  1: jmp    !x, 3           side 1 [2]
+	0x1300,	//  2: jmp    0               side 1 [3]
+	0xa342,	//  3: nop                    side 0 [3]
+		//     .wrap
+};
+
+static const struct pio_program ws2812_program = {
+	.instructions = ws2812_program_instructions,
+	.length = 4,
+	.origin = -1,
+};
+
+static inline pio_sm_config ws2812_program_get_default_config(uint offset)
+{
+	pio_sm_config c = pio_get_default_sm_config();
+
+	sm_config_set_wrap(&c, offset + ws2812_wrap_target, offset + ws2812_wrap);
+	sm_config_set_sideset(&c, 1, false, false);
+	return c;
+}
+
+static inline void ws2812_program_init(PIO pio, uint sm, uint offset, uint pin, uint freq,
+				       bool rgbw)
+{
+	int cycles_per_bit = ws2812_T1 + ws2812_T2 + ws2812_T3;
+	struct fp24_8 div;
+	pio_sm_config c;
+
+	pio_gpio_init(pio, pin);
+	pio_sm_set_consecutive_pindirs(pio, sm, pin, 1, true);
+	c = ws2812_program_get_default_config(offset);
+	sm_config_set_sideset_pins(&c, pin);
+	sm_config_set_out_shift(&c, false, true, rgbw ? 32 : 24);
+	sm_config_set_fifo_join(&c, PIO_FIFO_JOIN_TX);
+	div = make_fp24_8(clock_get_hz(clk_sys), freq * cycles_per_bit);
+	sm_config_set_clkdiv(&c, div);
+	pio_sm_init(pio, sm, offset, &c);
+	pio_sm_set_enabled(pio, sm, true);
+}
+
+static uint8_t ws2812_apply_gamma(uint8_t brightness, uint8_t val)
+{
+	int bright;
+
+	if (!val || !brightness)
+		return val;
+	bright = (val * brightness) / 255;
+	return ws2812_gamma[bright];
+}
+
+static inline uint8_t *rgbw_u32(const struct ws2812_pio_rp1_state *state,
+			       uint8_t r, uint8_t g, uint8_t b, uint8_t w, uint8_t *p)
+{
+	p[0] = ws2812_apply_gamma(state->brightness, w);
+	p[1] = ws2812_apply_gamma(state->brightness, b);
+	p[2] = ws2812_apply_gamma(state->brightness, r);
+	p[3] = ws2812_apply_gamma(state->brightness, g);
+	return p + 4;
+}
+
+static void ws2812_dma_complete(void *param)
+{
+	struct ws2812_pio_rp1_state *state = param;
+
+	complete(&state->dma_completion);
+}
+
+static void ws2812_update_leds(struct ws2812_pio_rp1_state *state, uint length)
+{
+	init_completion(&state->dma_completion);
+	if (!pio_sm_xfer_data(state->pio, state->sm, PIO_DIR_TO_SM, length, state->buffer, 0,
+			      (void (*)(void *))ws2812_dma_complete, state)) {
+		wait_for_completion(&state->dma_completion);
+		usleep_range(RESET_US, RESET_US + 100);
+	}
+}
+
+static void ws2812_clear_leds(struct ws2812_pio_rp1_state *state)
+{
+	uint8_t *p_buffer;
+	uint length;
+	int i;
+
+	p_buffer = state->buffer;
+	for (i = 0; i < state->num_leds; i++)
+		p_buffer = rgbw_u32(state, 0, 0, 0, 0, p_buffer);
+
+	length = (void *)p_buffer - (void *)state->buffer;
+
+	ws2812_update_leds(state, length);
+}
+
+/*
+ * Function to write the RGB buffer to the WS2812 leds, the input buffer
+ * contains a sequence of up to num_leds RGB32 integers, these are then
+ * gamma-corrected before being sent to the PIO state machine.
+ */
+
+static ssize_t ws2812_pio_rp1_write(struct file *filp, const char __user *buf, size_t count,
+				    loff_t *ppos)
+{
+	struct ws2812_pio_rp1_state *state;
+	uint32_t pixbuf_size;
+	unsigned long delay;
+	loff_t pos = *ppos;
+	int err = 0;
+
+	state = (struct ws2812_pio_rp1_state *)filp->private_data;
+	pixbuf_size = state->pixbuf_size;
+
+	if (pos > pixbuf_size)
+		return -EFBIG;
+
+	if (count > pixbuf_size) {
+		err = -EFBIG;
+		count = pixbuf_size;
+	}
+
+	if (pos + count > pixbuf_size) {
+		if (!err)
+			err = -ENOSPC;
+
+		count = pixbuf_size - pos;
+	}
+
+	if (!pos && count == 1) {
+		if (copy_from_user(&state->brightness, buf, 1))
+			return -EFAULT;
+	} else {
+		if (copy_from_user(state->pixbuf + pos, buf, count))
+			return -EFAULT;
+		pos += count;
+		state->write_end = (u32)pos;
+	}
+
+	*ppos = pos;
+
+	delay = (state->write_end == pixbuf_size) ? 0 : HZ / 20;
+	schedule_delayed_work(&state->deferred_work, delay);
+
+	return err ? err : count;
+}
+
+static void ws2812_pio_rp1_deferred_work(struct work_struct *work)
+{
+	struct ws2812_pio_rp1_state *state =
+		container_of(work, struct ws2812_pio_rp1_state, deferred_work.work);
+	uint8_t *p_buffer;
+	uint32_t *p_rgb;
+	int blank_bytes;
+	uint length;
+	int i;
+
+	blank_bytes = state->pixbuf_size - state->write_end;
+	if (blank_bytes > 0)
+		memset(state->pixbuf + state->write_end, 0, blank_bytes);
+
+	p_rgb = (uint32_t *)state->pixbuf;
+	p_buffer = state->buffer;
+
+	for (i = 0; i < state->num_leds; i++) {
+		uint32_t rgbw_pix = *(p_rgb++);
+
+		p_buffer = rgbw_u32(state,
+				    (uint8_t)(rgbw_pix >> 0),
+				    (uint8_t)(rgbw_pix >> 8),
+				    (uint8_t)(rgbw_pix >> 16),
+				    (uint8_t)(rgbw_pix >> 24),
+				    p_buffer);
+	}
+
+	length = (void *)p_buffer - (void *)state->buffer;
+
+	ws2812_update_leds(state, length);
+}
+
+static int ws2812_pio_rp1_open(struct inode *inode, struct file *file)
+{
+	struct ws2812_pio_rp1_state *state;
+
+	state  = container_of(inode->i_cdev, struct ws2812_pio_rp1_state, cdev);
+	file->private_data = state;
+
+	return 0;
+}
+
+const struct file_operations ws2812_pio_rp1_fops = {
+	.owner = THIS_MODULE,
+	.write = ws2812_pio_rp1_write,
+	.open = ws2812_pio_rp1_open,
+};
+
+/*
+ * Probe function
+ */
+static int ws2812_pio_rp1_probe(struct platform_device *pdev)
+{
+	struct device_node *np = pdev->dev.of_node;
+	struct of_phandle_args of_args = { 0 };
+	struct ws2812_pio_rp1_state *state;
+	struct device *dev = &pdev->dev;
+	struct device *char_dev;
+	const char *dev_name;
+	uint32_t brightness;
+	bool is_rp1;
+	int minor;
+	int ret;
+
+	state = devm_kzalloc(dev, sizeof(*state), GFP_KERNEL);
+	if (IS_ERR(state))
+		return PTR_ERR(state);
+
+	state->dev = dev;
+
+	platform_set_drvdata(pdev, state);
+
+	ret = of_property_read_u32(np, "rpi,num-leds", &state->num_leds);
+	if (ret)
+		return dev_err_probe(dev, ret, "Could not get num-leds\n");
+
+	brightness = 255;
+	of_property_read_u32(np, "rpi,brightness", &brightness);
+	state->brightness = min(brightness, 255);
+
+	state->pixbuf_size = state->num_leds * PIXEL_BYTES;
+
+	state->is_rgbw = of_property_read_bool(np, "rpi,rgbw");
+	state->gpiod = devm_gpiod_get(dev, "leds", GPIOD_ASIS);
+	if (IS_ERR(state->gpiod))
+		return dev_err_probe(dev, PTR_ERR(state->gpiod),
+				     "Could not get a gpio\n");
+
+	/* This must be an RP1 GPIO in the first bank, and retrieve the offset. */
+	/* Unfortunately I think this has to be done by parsing the gpios property */
+
+	/* This really shouldn't fail, given that we have a gpiod */
+	if (of_parse_phandle_with_args(np, "leds-gpios", "#gpio-cells", 0, &of_args))
+		return dev_err_probe(dev, -EINVAL,
+				     "Can't find gpio declaration\n");
+
+	is_rp1 = of_device_is_compatible(of_args.np, "raspberrypi,rp1-gpio");
+	of_node_put(of_args.np);
+	if (!is_rp1 || of_args.args_count != 2)
+		return dev_err_probe(dev, -EINVAL,
+				     "Not an RP1 gpio\n");
+
+	state->gpio = of_args.args[0];
+
+	state->pixbuf = devm_kmalloc(dev, state->pixbuf_size, GFP_KERNEL);
+	if (state->pixbuf == NULL)
+		return -ENOMEM;
+
+	state->buffer = devm_kmalloc(dev, state->num_leds * PIXEL_BYTES, GFP_KERNEL);
+	if (state->buffer == NULL)
+		return -ENOMEM;
+
+	ret = of_property_read_string(np, "dev-name", &dev_name);
+	if (ret) {
+		pr_err("Failed to read 'dev-name' property\n");
+		return ret;
+	}
+
+	state->pio = pio_open();
+	if (IS_ERR(state->pio))
+		return dev_err_probe(dev, PTR_ERR(state->pio),
+				     "Could not open PIO\n");
+
+	state->sm = pio_claim_unused_sm(state->pio, false);
+	if ((int)state->sm < 0) {
+		dev_err(dev, "No free PIO SM\n");
+		ret = -EBUSY;
+		goto fail_pio;
+	}
+
+	state->offset = pio_add_program(state->pio, &ws2812_program);
+	if (state->offset == PIO_ORIGIN_ANY) {
+		dev_err(dev, "Not enough PIO program space\n");
+		ret = -EBUSY;
+		goto fail_pio;
+	}
+
+	pio_sm_config_xfer(state->pio, state->sm, PIO_DIR_TO_SM, state->num_leds * sizeof(int), 1);
+
+	pio_sm_clear_fifos(state->pio, state->sm);
+	pio_sm_set_clkdiv(state->pio, state->sm, make_fp24_8(1, 1));
+	ws2812_program_init(state->pio, state->sm, state->offset, state->gpio, 800000,
+			    state->is_rgbw);
+
+	mutex_lock(&ws2812_pio_mutex);
+
+	if (!ws2812_pio_ref_count) {
+		ret = alloc_chrdev_region(&ws2812_pio_dev_num, 0, MAX_INSTANCES, DRIVER_NAME);
+		if (ret < 0) {
+			dev_err(dev, "alloc_chrdev_region failed (rc=%d)\n", ret);
+			goto fail_mutex;
+		}
+
+		ws2812_pio_class = class_create(DRIVER_NAME);
+		if (IS_ERR(ws2812_pio_class)) {
+			pr_err("Unable to create class " DRIVER_NAME "\n");
+			ret = PTR_ERR(ws2812_pio_class);
+			goto fail_chrdev;
+		}
+	}
+
+	ws2812_pio_ref_count++;
+
+	minor = ida_alloc_range(&ws2812_pio_ida, 0, MAX_INSTANCES - 1, GFP_KERNEL);
+	if (minor < 0) {
+		pr_err("No free instances\n");
+		ret = minor;
+		goto fail_class;
+
+	}
+
+	mutex_unlock(&ws2812_pio_mutex);
+
+	state->dev_num = MKDEV(MAJOR(ws2812_pio_dev_num), minor);
+	state->dev_name = devm_kasprintf(dev, GFP_KERNEL, dev_name, minor);
+
+	char_dev = device_create(ws2812_pio_class, NULL, state->dev_num, NULL, state->dev_name);
+
+	if (IS_ERR(char_dev)) {
+		pr_err("Unable to create device %s\n", state->dev_name);
+		ret = PTR_ERR(char_dev);
+		goto fail_ida;
+	}
+
+	state->cdev.owner = THIS_MODULE;
+	cdev_init(&state->cdev, &ws2812_pio_rp1_fops);
+
+	ret = cdev_add(&state->cdev, state->dev_num, 1);
+	if (ret) {
+		pr_err("cdev_add failed\n");
+		goto fail_device;
+	}
+
+	INIT_DELAYED_WORK(&state->deferred_work, ws2812_pio_rp1_deferred_work);
+
+	ws2812_clear_leds(state);
+
+	dev_info(&pdev->dev, "Instantiated %d LEDs on GPIO %d as /dev/%s\n",
+		 state->num_leds, state->gpio, state->dev_name);
+
+	return 0;
+
+fail_device:
+	device_destroy(ws2812_pio_class, state->dev_num);
+fail_ida:
+	mutex_lock(&ws2812_pio_mutex);
+	ida_free(&ws2812_pio_ida, minor);
+fail_class:
+	ws2812_pio_ref_count--;
+	if (ws2812_pio_ref_count)
+		goto fail_mutex;
+	class_destroy(ws2812_pio_class);
+fail_chrdev:
+	unregister_chrdev_region(ws2812_pio_dev_num, MAX_INSTANCES);
+fail_mutex:
+	mutex_unlock(&ws2812_pio_mutex);
+fail_pio:
+	pio_close(state->pio);
+
+	return ret;
+}
+
+static void ws2812_pio_rp1_remove(struct platform_device *pdev)
+{
+	struct ws2812_pio_rp1_state *state = platform_get_drvdata(pdev);
+
+	cancel_delayed_work(&state->deferred_work);
+	platform_set_drvdata(pdev, NULL);
+
+	cdev_del(&state->cdev);
+	device_destroy(ws2812_pio_class, state->dev_num);
+
+	mutex_lock(&ws2812_pio_mutex);
+	ida_free(&ws2812_pio_ida, MINOR(state->dev_num));
+	ws2812_pio_ref_count--;
+	if (!ws2812_pio_ref_count) {
+		class_destroy(ws2812_pio_class);
+		unregister_chrdev_region(ws2812_pio_dev_num, MAX_INSTANCES);
+	}
+	mutex_unlock(&ws2812_pio_mutex);
+
+	pio_close(state->pio);
+}
+
+static const struct of_device_id ws2812_pio_rp1_match[] = {
+	{ .compatible = "raspberrypi,ws2812-pio-rp1" },
+	{ }
+};
+MODULE_DEVICE_TABLE(of, ws2812_pio_rp1_match);
+
+static struct platform_driver ws2812_pio_rp1_driver = {
+	.driver = {
+		.name = "ws2812-pio-rp1",
+		.of_match_table = ws2812_pio_rp1_match,
+	},
+	.probe = ws2812_pio_rp1_probe,
+	.remove_new  = ws2812_pio_rp1_remove,
+};
+module_platform_driver(ws2812_pio_rp1_driver);
+
+MODULE_DESCRIPTION("WS2812 PIO RP1 driver");
+MODULE_AUTHOR("Phil Elwell");
+MODULE_LICENSE("GPL");
diff --git a/drivers/mmc/core/block.c b/drivers/mmc/core/block.c
index 08b8276e1da9..8ace6dbfc0d2 100644
--- a/drivers/mmc/core/block.c
+++ b/drivers/mmc/core/block.c
@@ -218,6 +218,13 @@ static DEFINE_MUTEX(open_lock);
 module_param(perdev_minors, int, 0444);
 MODULE_PARM_DESC(perdev_minors, "Minors numbers to allocate per device");
 
+/*
+ * Allow quirks to be overridden for the current card
+ */
+static char *card_quirks;
+module_param(card_quirks, charp, 0644);
+MODULE_PARM_DESC(card_quirks, "Force the use of the indicated quirks (a bitfield)");
+
 static inline int mmc_blk_part_switch(struct mmc_card *card,
 				      unsigned int part_type);
 static void mmc_blk_rw_rq_prep(struct mmc_queue_req *mqrq,
@@ -927,7 +934,10 @@ static int mmc_blk_part_switch_pre(struct mmc_card *card,
 
 	if ((part_type & mask) == rpmb) {
 		if (card->ext_csd.cmdq_en) {
-			ret = mmc_cmdq_disable(card);
+			if (mmc_card_sd(card))
+				ret = mmc_sd_cmdq_disable(card);
+			else
+				ret = mmc_cmdq_disable(card);
 			if (ret)
 				return ret;
 		}
@@ -946,8 +956,12 @@ static int mmc_blk_part_switch_post(struct mmc_card *card,
 
 	if ((part_type & mask) == rpmb) {
 		mmc_retune_unpause(card->host);
-		if (card->reenable_cmdq && !card->ext_csd.cmdq_en)
-			ret = mmc_cmdq_enable(card);
+		if (card->reenable_cmdq && !card->ext_csd.cmdq_en) {
+			if (mmc_card_sd(card))
+				ret = mmc_sd_cmdq_enable(card);
+			else
+				ret = mmc_cmdq_enable(card);
+		}
 	}
 
 	return ret;
@@ -1158,7 +1172,10 @@ static void mmc_blk_issue_drv_op(struct mmc_queue *mq, struct request *req)
 	switch (mq_rq->drv_op) {
 	case MMC_DRV_OP_IOCTL:
 		if (card->ext_csd.cmdq_en) {
-			ret = mmc_cmdq_disable(card);
+			if (mmc_card_sd(card))
+				ret = mmc_sd_cmdq_disable(card);
+			else
+				ret = mmc_cmdq_disable(card);
 			if (ret)
 				break;
 		}
@@ -1176,8 +1193,12 @@ static void mmc_blk_issue_drv_op(struct mmc_queue *mq, struct request *req)
 		/* Always switch back to main area after RPMB access */
 		if (rpmb_ioctl)
 			mmc_blk_part_switch(card, 0);
-		else if (card->reenable_cmdq && !card->ext_csd.cmdq_en)
-			mmc_cmdq_enable(card);
+		else if (card->reenable_cmdq && !card->ext_csd.cmdq_en) {
+			if (mmc_card_sd(card))
+				mmc_sd_cmdq_enable(card);
+			else
+				mmc_cmdq_enable(card);
+		}
 		break;
 	case MMC_DRV_OP_BOOT_WP:
 		ret = mmc_switch(card, EXT_CSD_CMD_SET_NORMAL, EXT_CSD_BOOT_WP,
@@ -1218,12 +1239,26 @@ static void mmc_blk_issue_erase_rq(struct mmc_queue *mq, struct request *req,
 	unsigned int from, nr;
 	int err = 0;
 	blk_status_t status = BLK_STS_OK;
+	bool restart_cmdq = false;
 
 	if (!mmc_can_erase(card)) {
 		status = BLK_STS_NOTSUPP;
 		goto fail;
 	}
 
+	/*
+	 * Only Discard ops are supported with SD cards in CQ mode
+	 * (SD Physical Spec v9.00 4.19.2)
+	 */
+	if (mmc_card_sd(card) && card->ext_csd.cmdq_en && erase_arg != SD_DISCARD_ARG) {
+		restart_cmdq = true;
+		err = mmc_sd_cmdq_disable(card);
+		if (err) {
+			status = BLK_STS_IOERR;
+			goto fail;
+		}
+	}
+
 	from = blk_rq_pos(req);
 	nr = blk_rq_sectors(req);
 
@@ -1244,6 +1279,11 @@ static void mmc_blk_issue_erase_rq(struct mmc_queue *mq, struct request *req,
 		status = BLK_STS_IOERR;
 	else
 		mmc_blk_reset_success(md, type);
+
+	if (restart_cmdq)
+		err = mmc_sd_cmdq_enable(card);
+	if (err)
+		status = BLK_STS_IOERR;
 fail:
 	blk_mq_end_request(req, status);
 }
@@ -1565,6 +1605,7 @@ static void mmc_blk_cqe_complete_rq(struct mmc_queue *mq, struct request *req)
 	struct request_queue *q = req->q;
 	struct mmc_host *host = mq->card->host;
 	enum mmc_issue_type issue_type = mmc_issue_type(mq, req);
+	bool write = req_op(req) == REQ_OP_WRITE;
 	unsigned long flags;
 	bool put_card;
 	int err;
@@ -1596,6 +1637,8 @@ static void mmc_blk_cqe_complete_rq(struct mmc_queue *mq, struct request *req)
 
 	spin_lock_irqsave(&mq->lock, flags);
 
+	if (write)
+		mq->pending_writes--;
 	mq->in_flight[issue_type] -= 1;
 
 	put_card = (mmc_tot_in_flight(mq) == 0);
@@ -2004,7 +2047,7 @@ static void mmc_blk_mq_rw_recovery(struct mmc_queue *mq, struct request *req)
 		return;
 	}
 
-	if (rq_data_dir(req) == READ && brq->data.blocks >
+	if (0 && rq_data_dir(req) == READ && brq->data.blocks >
 			queue_physical_block_size(mq->queue) >> 9) {
 		/* Read one (native) sector at a time */
 		mmc_blk_read_single(mq, req);
@@ -2112,6 +2155,8 @@ static void mmc_blk_mq_complete_rq(struct mmc_queue *mq, struct request *req)
 	struct mmc_queue_req *mqrq = req_to_mmc_queue_req(req);
 	unsigned int nr_bytes = mqrq->brq.data.bytes_xfered;
 
+	if (req_op(req) == REQ_OP_WRITE)
+		mq->pending_writes--;
 	if (nr_bytes) {
 		if (blk_update_request(req, BLK_STS_OK, nr_bytes))
 			blk_mq_requeue_request(req, true);
@@ -2206,13 +2251,17 @@ static void mmc_blk_mq_poll_completion(struct mmc_queue *mq,
 	mmc_blk_urgent_bkops(mq, mqrq);
 }
 
-static void mmc_blk_mq_dec_in_flight(struct mmc_queue *mq, enum mmc_issue_type issue_type)
+static void mmc_blk_mq_dec_in_flight(struct mmc_queue *mq, enum mmc_issue_type issue_type,
+				     bool write)
 {
 	unsigned long flags;
 	bool put_card;
 
 	spin_lock_irqsave(&mq->lock, flags);
 
+	if (write)
+		mq->pending_writes--;
+
 	mq->in_flight[issue_type] -= 1;
 
 	put_card = (mmc_tot_in_flight(mq) == 0);
@@ -2227,6 +2276,7 @@ static void mmc_blk_mq_post_req(struct mmc_queue *mq, struct request *req,
 				bool can_sleep)
 {
 	enum mmc_issue_type issue_type = mmc_issue_type(mq, req);
+	bool write = req_op(req) == REQ_OP_WRITE;
 	struct mmc_queue_req *mqrq = req_to_mmc_queue_req(req);
 	struct mmc_request *mrq = &mqrq->brq.mrq;
 	struct mmc_host *host = mq->card->host;
@@ -2246,7 +2296,7 @@ static void mmc_blk_mq_post_req(struct mmc_queue *mq, struct request *req,
 			blk_mq_complete_request(req);
 	}
 
-	mmc_blk_mq_dec_in_flight(mq, issue_type);
+	mmc_blk_mq_dec_in_flight(mq, issue_type, write);
 }
 
 void mmc_blk_mq_recovery(struct mmc_queue *mq)
@@ -3255,6 +3305,8 @@ static int mmc_blk_probe(struct mmc_card *card)
 {
 	struct mmc_blk_data *md;
 	int ret = 0;
+	char quirk_str[24];
+	char cap_str[10];
 
 	/*
 	 * Check that the card supports the command class(es) we need.
@@ -3262,7 +3314,16 @@ static int mmc_blk_probe(struct mmc_card *card)
 	if (!(card->csd.cmdclass & CCC_BLOCK_READ))
 		return -ENODEV;
 
-	mmc_fixup_device(card, mmc_blk_fixups);
+	if (card_quirks) {
+		unsigned long quirks;
+		if (kstrtoul(card_quirks, 0, &quirks) == 0)
+			card->quirks = (unsigned int)quirks;
+		else
+			pr_err("mmc_block: Invalid card_quirks parameter '%s'\n",
+			       card_quirks);
+	}
+	else
+		mmc_fixup_device(card, mmc_blk_fixups);
 
 	card->complete_wq = alloc_workqueue("mmc_complete",
 					WQ_MEM_RECLAIM | WQ_HIGHPRI, 0);
@@ -3277,6 +3338,17 @@ static int mmc_blk_probe(struct mmc_card *card)
 		goto out_free;
 	}
 
+	string_get_size((u64)get_capacity(md->disk), 512, STRING_UNITS_2,
+			cap_str, sizeof(cap_str));
+	if (card->quirks)
+		snprintf(quirk_str, sizeof(quirk_str),
+			 " (quirks 0x%08x)", card->quirks);
+	else
+		quirk_str[0] = '\0';
+	pr_info("%s: %s %s %s%s%s\n",
+		md->disk->disk_name, mmc_card_id(card), mmc_card_name(card),
+		cap_str, md->read_only ? " (ro)" : "", quirk_str);
+
 	ret = mmc_blk_alloc_parts(card, md);
 	if (ret)
 		goto out;
diff --git a/drivers/mmc/core/bus.c b/drivers/mmc/core/bus.c
index 4f3a26676ccb..27e2ff70165d 100644
--- a/drivers/mmc/core/bus.c
+++ b/drivers/mmc/core/bus.c
@@ -266,6 +266,8 @@ static void mmc_release_card(struct device *dev)
 
 	sdio_free_common_cis(card);
 
+	kfree(card->ext_reg_buf);
+
 	kfree(card->info);
 
 	kfree(card);
diff --git a/drivers/mmc/core/card.h b/drivers/mmc/core/card.h
index 9cbdd240c3a7..a36cda051d16 100644
--- a/drivers/mmc/core/card.h
+++ b/drivers/mmc/core/card.h
@@ -88,11 +88,13 @@ struct mmc_fixup {
 #define CID_MANFID_GIGASTONE    0x12
 #define CID_MANFID_MICRON       0x13
 #define CID_MANFID_SAMSUNG      0x15
+#define CID_MANFID_SAMSUNG_SD	0x1b
 #define CID_MANFID_APACER       0x27
 #define CID_MANFID_SWISSBIT     0x5D
 #define CID_MANFID_KINGSTON     0x70
 #define CID_MANFID_HYNIX	0x90
 #define CID_MANFID_KINGSTON_SD	0x9F
+#define CID_MANFID_LONGSYS_SD	0xAD
 #define CID_MANFID_NUMONYX	0xFE
 
 #define END_FIXUP { NULL }
@@ -300,4 +302,9 @@ static inline int mmc_card_no_uhs_ddr50_tuning(const struct mmc_card *c)
 	return c->quirks & MMC_QUIRK_NO_UHS_DDR50_TUNING;
 }
 
+static inline int mmc_card_working_sd_cq(const struct mmc_card *c)
+{
+	return c->quirks & MMC_QUIRK_WORKING_SD_CQ;
+}
+
 #endif
diff --git a/drivers/mmc/core/core.c b/drivers/mmc/core/core.c
index 327029f5c59b..95d40fd26369 100644
--- a/drivers/mmc/core/core.c
+++ b/drivers/mmc/core/core.c
@@ -455,6 +455,7 @@ int mmc_cqe_start_req(struct mmc_host *host, struct mmc_request *mrq)
 		goto out_err;
 
 	trace_mmc_request_start(host, mrq);
+	led_trigger_event(host->led, LED_FULL);
 
 	return 0;
 
@@ -542,10 +543,18 @@ int mmc_cqe_recovery(struct mmc_host *host)
 	 * Recovery is expected seldom, if at all, but it reduces performance,
 	 * so make sure it is not completely silent.
 	 */
-	pr_warn("%s: running CQE recovery\n", mmc_hostname(host));
+	pr_warn_ratelimited("%s: running CQE recovery\n", mmc_hostname(host));
 
 	host->cqe_ops->cqe_recovery_start(host);
 
+	err = mmc_detect_card_removed(host);
+	if (err) {
+		host->cqe_ops->cqe_recovery_finish(host);
+		host->cqe_ops->cqe_off(host);
+		mmc_retune_release(host);
+		return err;
+	}
+
 	memset(&cmd, 0, sizeof(cmd));
 	cmd.opcode       = MMC_STOP_TRANSMISSION;
 	cmd.flags        = MMC_RSP_R1B | MMC_CMD_AC;
@@ -556,7 +565,11 @@ int mmc_cqe_recovery(struct mmc_host *host)
 	mmc_poll_for_busy(host->card, MMC_CQE_RECOVERY_TIMEOUT, true, MMC_BUSY_IO);
 
 	memset(&cmd, 0, sizeof(cmd));
-	cmd.opcode       = MMC_CMDQ_TASK_MGMT;
+	if (mmc_card_sd(host->card))
+		cmd.opcode = SD_CMDQ_TASK_MGMT;
+	else
+		cmd.opcode = MMC_CMDQ_TASK_MGMT;
+
 	cmd.arg          = 1; /* Discard entire queue */
 	cmd.flags        = MMC_RSP_R1B | MMC_CMD_AC;
 	cmd.flags       &= ~MMC_RSP_CRC; /* Ignore CRC */
@@ -1818,7 +1831,8 @@ EXPORT_SYMBOL(mmc_erase);
 
 int mmc_can_erase(struct mmc_card *card)
 {
-	if (card->csd.cmdclass & CCC_ERASE && card->erase_size)
+	if (card->csd.cmdclass & CCC_ERASE && card->erase_size &&
+	    !(card->quirks & MMC_QUIRK_ERASE_BROKEN))
 		return 1;
 	return 0;
 }
diff --git a/drivers/mmc/core/host.c b/drivers/mmc/core/host.c
index 48bda70145ee..018b77ade4c6 100644
--- a/drivers/mmc/core/host.c
+++ b/drivers/mmc/core/host.c
@@ -272,7 +272,7 @@ EXPORT_SYMBOL(mmc_of_parse_clk_phase);
 int mmc_of_parse(struct mmc_host *host)
 {
 	struct device *dev = host->parent;
-	u32 bus_width, drv_type, cd_debounce_delay_ms;
+	u32 bus_width, drv_type, cd_debounce_delay_ms, cq_allow;
 	int ret;
 
 	if (!dev || !dev_fwnode(dev))
@@ -407,6 +407,15 @@ int mmc_of_parse(struct mmc_host *host)
 		host->caps2 &= ~(MMC_CAP2_HS400_1_8V | MMC_CAP2_HS400_1_2V |
 				 MMC_CAP2_HS400_ES);
 
+	cq_allow = 0;
+	/*
+	 * Downstream property - if a u32 and 2 instead of a bool,
+	 * trust most A2 SD cards claiming CQ support.
+	 */
+	device_property_read_u32(dev, "supports-cqe", &cq_allow);
+	if (cq_allow == 2)
+		host->caps2 |= MMC_CAP2_SD_CQE_PERMISSIVE;
+
 	/* Must be after "non-removable" check */
 	if (device_property_read_u32(dev, "fixed-emmc-driver-type", &drv_type) == 0) {
 		if (host->caps & MMC_CAP_NONREMOVABLE)
diff --git a/drivers/mmc/core/mmc.c b/drivers/mmc/core/mmc.c
index 6a23be214543..851701b11266 100644
--- a/drivers/mmc/core/mmc.c
+++ b/drivers/mmc/core/mmc.c
@@ -1657,6 +1657,7 @@ static int mmc_init_card(struct mmc_host *host, u32 ocr,
 		card->ocr = ocr;
 		card->type = MMC_TYPE_MMC;
 		card->rca = 1;
+		card->max_posted_writes = 1;
 		memcpy(card->raw_cid, cid, sizeof(card->raw_cid));
 	}
 
@@ -1915,13 +1916,14 @@ static int mmc_init_card(struct mmc_host *host, u32 ocr,
 			host->cqe_enabled = true;
 
 			if (card->ext_csd.cmdq_en) {
-				pr_info("%s: Command Queue Engine enabled\n",
-					mmc_hostname(host));
+				pr_info("%s: Command Queue Engine enabled, %u tags\n",
+					mmc_hostname(host), card->ext_csd.cmdq_depth);
 			} else {
 				host->hsq_enabled = true;
 				pr_info("%s: Host Software Queue enabled\n",
 					mmc_hostname(host));
 			}
+			card->max_posted_writes = card->ext_csd.cmdq_depth;
 		}
 	}
 
diff --git a/drivers/mmc/core/queue.c b/drivers/mmc/core/queue.c
index 4d6844261912..6d99da3a22fb 100644
--- a/drivers/mmc/core/queue.c
+++ b/drivers/mmc/core/queue.c
@@ -266,6 +266,11 @@ static blk_status_t mmc_mq_queue_rq(struct blk_mq_hw_ctx *hctx,
 			spin_unlock_irq(&mq->lock);
 			return BLK_STS_RESOURCE;
 		}
+		if (!host->hsq_enabled && host->cqe_enabled && req_op(req) == REQ_OP_WRITE &&
+		    mq->pending_writes >= card->max_posted_writes) {
+			spin_unlock_irq(&mq->lock);
+			return BLK_STS_RESOURCE;
+		}
 		break;
 	default:
 		/*
@@ -282,6 +287,8 @@ static blk_status_t mmc_mq_queue_rq(struct blk_mq_hw_ctx *hctx,
 	/* Parallel dispatch of requests is not supported at the moment */
 	mq->busy = true;
 
+	if (req_op(req) == REQ_OP_WRITE)
+		mq->pending_writes++;
 	mq->in_flight[issue_type] += 1;
 	get_card = (mmc_tot_in_flight(mq) == 1);
 	cqe_retune_ok = (mmc_cqe_qcnt(mq) == 1);
@@ -321,6 +328,8 @@ static blk_status_t mmc_mq_queue_rq(struct blk_mq_hw_ctx *hctx,
 		bool put_card = false;
 
 		spin_lock_irq(&mq->lock);
+		if (req_op(req) == REQ_OP_WRITE)
+			mq->pending_writes--;
 		mq->in_flight[issue_type] -= 1;
 		if (mmc_tot_in_flight(mq) == 0)
 			put_card = true;
diff --git a/drivers/mmc/core/queue.h b/drivers/mmc/core/queue.h
index 1498840a4ea0..39180d97911b 100644
--- a/drivers/mmc/core/queue.h
+++ b/drivers/mmc/core/queue.h
@@ -79,6 +79,7 @@ struct mmc_queue {
 	struct request_queue	*queue;
 	spinlock_t		lock;
 	int			in_flight[MMC_ISSUE_MAX];
+	int			pending_writes;
 	unsigned int		cqe_busy;
 #define MMC_CQE_DCMD_BUSY	BIT(0)
 	bool			busy;
